/*
 Copyright 2007 Politecnico di Milano
 This file is part of Dynamo.

 Dynamo is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 3 of the License, or
 (at your option) any later version.

 Dynamo is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

import it.polimi.monitor.nodes.AliasNodes;
import it.polimi.monitor.nodes.Aliases;
import it.polimi.recovery.AtomicRecoveryAction;
import it.polimi.recovery.Recovery;
import it.polimi.recovery.data.ProcessParams;
import it.polimi.recovery.data.RecoveryParams;
import it.polimi.recovery.data.ServiceInvocationParams;
import it.polimi.recovery.data.SupervisionParams;
import it.polimi.recovery.nodes.RecoveryStepNode;


public class TestRecovery
{

	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		String xmlMailConfig = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" +
								"<!DOCTYPE properties SYSTEM \"http://java.sun.com/dtd/properties.dtd\">" +
								"<properties>" +
								   "<entry key=\"mail.smtp.auth\">true</entry>" +
								   "<entry key=\"mail.smtp.host\">smtp.email.it</entry>" +
								   "<entry key=\"mail.smtp.user\"></entry>" +
								   "<entry key=\"mail.smtp.password\"></entry>" +
								   "<entry key=\"from\"></entry>" +
								"</properties>";	
		
		String configHvar="<webservice>"  +
							"<wsdl>http://localhost:8080/HistoricalVariable/HistoricalVariableBeans?wsdl</wsdl>" +
							"<store_wm>createHistoricalVariable</store_wm>" +
							"<retrieve_wm>findHistoricalVariable</retrieve_wm>" +
							"<processID>process</processID>" +
							"<assertionType>0</assertionType>" +
							"<location>pippo</location>" +
							"<userID>luca</userID>" +
							"<instanceID>1233</instanceID>" +
							"</webservice>";

		String recoveryRule = "if (let $doseOld = returnInt('wsdl','op','input',ret);($doseNew) <= ($doseOld) * 1.075 && " +
						    "($doseNew) >= ($doseOld) * 0.925;) {" +
						    "retry(1) or " +
						    "notify(\"mess\", \"admin_email\") and " +
						       "rebind(\"second_LAB_URI\") or " +
						    "notify(\"mess\", \"admin_email\") and " +
						       "call(\"private_LAB\", \"analyze\", \"data\", \"XSLT\") or " +
						          "callback(\"Emergency\", \"input\") " + 
						        "}" +
						    "else {" +
						    	"notify(\"mess\", \"admin_email\") and " +
						    		"callback(\"Emergency\", \"input\") and " +
								    "retry(1)" +
						    "}";

		String data="<monitor_data><getRouteIn>" +
		"<params><start>ciaocon</start><start>cssssocon</start></params><finish><easting>21</easting>" +
		"<northing>55</northing><zone>roma</zone></finish></getRouteIn><getRestaurantsOut><parameters>" +
		"<getRestaurantsResult><Restaurant><location><easting>21</easting><northing>55</northing><zone>roma</zone></location>" +
		"<MapService_getMapResponse><result>http://localhost:8080/DemoImages/images/im004.jpg</result></MapService_getMapResponse>" +
		"<location><easting>21</easting><northing>55</northing><zone>roma</zone></location>" +
		"<location><easting>21</easting><northing>55</northing><zone>roma</zone></location>" +
		"<location><easting>21</easting><northing>55</northing><zone>roma</zone></location>" +
		"<location><easting>21</easting><northing>55</northing><zone>roma</zone></location>" +
		"<location><easting>21</easting><northing>55</northing><zone>roma</zone></location>" +
		"</Restaurant><Restaurant>" +
		"<location><easting>21</easting><northing>55</northing><zone>roma</zone></location>" +
		"<location><easting>21</easting><northing>55</northing><zone>roma</zone></location>" +
		"<location><easting>21</easting><northing>55</northing><zone>roma</zone></location>" +
		"<location><easting>21</easting><northing>55</northing><zone>roma</zone></location>" +
		"<location><easting>21</easting><northing>55</northing><zone>roma</zone></location>" +
		"<location><easting>21</easting><northing>55</northing><zone>roma</zone></location>" +
		"</Restaurant></getRestaurantsResult></parameters></getRestaurantsOut></monitor_data>";
//		recoveryRule = "{" +
//			    "retry(1) or " +
//			    "notify(\"mess\", \"admin_email\") and " +
//			       "rebind(\"second_LAB_URI\") or " +
//			    "notify(\"mess\", \"admin_email\") and " +
//			       "call(\"private_LAB\", \"analyze\", \"data\", \"XSLT\") or " +
//			          "callback(\"Emergency\", \"input\") " + 
//			        "}";
//		
//		recoveryRule = "{" +
//						    	"notify(\"mess\", \"admin_email\") and " +
//						    		"callback(\"Emergency\", \"input\") and " +
//								    "retry(1)" +
//						    "}";
//		
//		recoveryRule = "let $doseOld = returnInt('wsdl','op','input',ret);($doseNew) <= ($doseOld) * 1.075 && " +
//						    "($doseNew) >= ($doseOld) * 0.925;";
		
//		recovery = "{halt() or notify('mail','mess')}";

//		recoveryRule = "{ignore() and halt()}";
		
//		recoveryRule = "{change_supervision_params('3', , 'providers', 'permanent')}";
		
//		recoveryRule = "{call('wsdl', 'op','<InvokeServiceParameters><input>' + $getRouteIn/params/start + '</input></InvokeServiceParameters>')}";

//		recoveryRule = "if($hRes < 100;){ignore()}else{call('http://localhost:8080/ImageEditor/ImageEditorBean?wsdl','editImages','<InvokeServiceParameters><imageURL>' + $MapService_getMapResponse/result + '</imageURL></InvokeServiceParameters>') or notify('Could not load a map with a suitable size','doctor.b@fastwebnet.it') and halt()}";
//		ProcessParams processParams = new ProcessParams("pID", 2, "diego", "location", "wsdlURL", true, 3);
//		
//		SupervisionParams supervisionParams = new SupervisionParams("", recoveryRule, data, 5, configHvar);
//		
//		ServiceInvocationParams serviceInvocationParams = new ServiceInvocationParams();
//		
//		RecoveryParams recoveryParams = new RecoveryParams(processParams, supervisionParams, serviceInvocationParams);
//		recoveryParams.setXmlMailConfig(xmlMailConfig);
//		// TODO Auto-generated method stub
//		Recovery recovery = new Recovery(recoveryParams, new Aliases(), new AliasNodes());
//		System.out.println("Recovery: " + recovery.DoRecovery() + " - message: " + recovery.GetRecoveryMessage());
		
//		AtomicRecoveryAction.Notify("Prova", "doctor.b@fastwebnet.it", xmlMailConfig);
		
//		AtomicRecoveryAction.RetrieveServiceEndpoint("http://localhost:8080/MapServiceBU/MapServiceBackUpBean?wsdl");
		
//		String rule = "let $hRes = returnInt('http://127.0.0.1:8080/ImageVerifierServiceBeanService/ImageVerifierServiceBean?wsdl','getHRes','<InvokeServiceParameters><imageURL>' + $MapService_getMapResponse/ns6:result + '</imageURL></InvokeServiceParameters>',/Response/result);$hRes <= 80;";
//		
//		System.out.println(RecoveryStepNode.removeNamespaceFromRule(rule));
//		System.out.println("old: " + rule);
	}

}
