/*
 Copyright 2007 Politecnico di Milano
 This file is part of Dynamo.

 Dynamo is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 3 of the License, or
 (at your option) any later version.

 Dynamo is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package it.polimi.monitor.nodes;

import it.polimi.exception.WSCoLException;
import it.polimi.monitor.InputMonitor;
import antlr.Token;



public class SimpleAST extends NodeWSCoL {
	private static final long serialVersionUID = -3182266147175648399L;
	private String value=null;

    public SimpleAST (Token tok) {
    	this.value = tok.getText();
    	serializeTag=calculateSerialize();
    	logger.info("Set value " + this.value);
    }
    
	public void evaluate(InputMonitor inputMonitor, Aliases aliases , AliasNodes tempAliases ) throws WSCoLException {
		logger.info("Evaluate " + value);
	}
	@Override
	public String getMonitoringValue() throws WSCoLException {
		return value;
	}
	
	/**
	 * Get value of SimpleAst
	 * @return the value
	 */
	public String getValue() {
		return value;
	}

	/**
	 * Set value of the SimpleAST
	 * @param value the value to set
	 */
	public void setValue(String value) {
		this.value = value;
	}
	/*
	@Override
	public boolean equals(Object obj) {
		if (obj instanceof NodeWSCoL) {
			return this.value.equals(((NodeWSCoL) obj).getMonitoringValue());
		} else 
			return false;
	}*/
	@Override
	public String toString(){
		return value;
	}
	private String calculateSerialize(){
		if (value.equals("false")||value.equals("true"))
			return "boolean";
		else 
			try{
				Double.parseDouble(value);
				return "number";
			} catch (NumberFormatException e) { 
				return "string";
			}
	}

}
